 
#include "MPU9250.h"
#define FASTLED_INTERNAL
//
#include "FastLED.h"
#define NUM_LEDS_PER_STRIP 16

CRGB RIGHT[NUM_LEDS_PER_STRIP];
CRGB LEFT[NUM_LEDS_PER_STRIP];
CRGB FWD[NUM_LEDS_PER_STRIP];
CRGB BACK[NUM_LEDS_PER_STRIP];
CRGB UP[NUM_LEDS_PER_STRIP];
CRGB DOWN[NUM_LEDS_PER_STRIP];
//
MPU9250 IMU(Wire, 0x68);
int status;

const int MAX_LEVEL = 6;
int sequence[MAX_LEVEL];
int your_sequence[MAX_LEVEL];
int level = 6;

int velocity = 1000;
int maxnum = 300;

int countRIGHT = 0;
int countLEFT = 0;
int countFWD = 0;
int countBACK = 0;
int countUP = 0;
int countDOWN = 0;

int state = 1;
unsigned long changeTime = 0;
int delayTime = 15;
int buttonPin = A3;
int buttonState = 0;
int buttonStatePrev = 0;

void setup() {
  Serial.begin(9600);
  while (!Serial) {}
  status = IMU.begin();

  FastLED.addLeds<NEOPIXEL, 2>(RIGHT, NUM_LEDS_PER_STRIP);
  FastLED.addLeds<NEOPIXEL, 3>(LEFT, NUM_LEDS_PER_STRIP);
  FastLED.addLeds<NEOPIXEL, 4>(FWD, NUM_LEDS_PER_STRIP);
  FastLED.addLeds<NEOPIXEL, 5>(BACK, NUM_LEDS_PER_STRIP);
  FastLED.addLeds<NEOPIXEL, 6>(UP, NUM_LEDS_PER_STRIP);
  FastLED.addLeds<NEOPIXEL, 7>(DOWN, NUM_LEDS_PER_STRIP);

  FastLED.setBrightness(70);

  pinMode(A3, INPUT);

  changeTime = millis();

  Serial.println("ON");
}

void loop() {
  buttonStatePrev = buttonState;
  buttonState = digitalRead(buttonPin);

  switch (state) {
    case 1:
      if (millis() - changeTime >= 250) {
        changeTime = millis();
        spinningRainbow();
//        status = IMU.begin();
//          Serial.print("x ");
//  Serial.print(IMU.getAccelX_mss(),2);
//  Serial.print("y ");
//  Serial.print(IMU.getAccelY_mss(),2);
//  Serial.print("z ");
//  Serial.println(IMU.getAccelZ_mss(),2);
      }

      if (buttonState == HIGH && buttonStatePrev == LOW) {

        state = 2;
        fill_solid( RIGHT, NUM_LEDS_PER_STRIP, CRGB::Black);            //turning off leds
        fill_solid( LEFT, NUM_LEDS_PER_STRIP, CRGB::Black);
        fill_solid( FWD, NUM_LEDS_PER_STRIP, CRGB::Black);
        fill_solid( BACK, NUM_LEDS_PER_STRIP, CRGB::Black);
        fill_solid( UP, NUM_LEDS_PER_STRIP, CRGB::Black);
        fill_solid( DOWN, NUM_LEDS_PER_STRIP, CRGB::Black);
        FastLED.delay(250);
        break;
      }
      break;
    case 2:
      generate_sequence();
      show_sequence();
      get_sequence();
      state = 1;
      changeTime = millis();
      break;
  }
}
void spinningRainbow() {
  static byte initialHue = 0;
  initialHue = initialHue + 1;
  byte changeInHue = 255 / 100;
  fill_rainbow( RIGHT, NUM_LEDS_PER_STRIP,  initialHue, changeInHue);
  fill_rainbow( LEFT, NUM_LEDS_PER_STRIP,  initialHue, changeInHue);
  fill_rainbow( FWD, NUM_LEDS_PER_STRIP,  initialHue, changeInHue);
  fill_rainbow( BACK, NUM_LEDS_PER_STRIP,  initialHue, changeInHue);
  fill_rainbow( UP, NUM_LEDS_PER_STRIP, initialHue, changeInHue);
  fill_rainbow( DOWN, NUM_LEDS_PER_STRIP,  initialHue, changeInHue);
  FastLED.show();
}
void generate_sequence() {

  long randomVals[6];
  long rand;
  int count = 0;

  memset(randomVals, 0, sizeof(randomVals));

  randomSeed(millis());
  while (count < 6) {          //create 6 random but unique numbers
    rand = random(0, 6);
    if (randomVals[rand] == 0) {
      randomVals[rand] = count + 2;
      count++;
    }
  }
  for (int i = 0; i < 6; i++) {
    sequence[i] = randomVals[i];       // sequence of 6 random but unique numbers
    Serial.println(sequence[i]);
  }
}
void show_sequence()
{

  for (int i = 0; i < level; i++) {
    if (sequence[i] == 2) {
      fill_solid( RIGHT, NUM_LEDS_PER_STRIP, CRGB::Blue);
      FastLED.show();
      delay(velocity);
      fill_solid( RIGHT, NUM_LEDS_PER_STRIP, CRGB::Black);
      FastLED.show();
      delay(velocity);
    }
    if (sequence[i] == 3) {
      fill_solid( LEFT, NUM_LEDS_PER_STRIP, CRGB::Blue);
      FastLED.show();
      delay(velocity);
      fill_solid( LEFT, NUM_LEDS_PER_STRIP, CRGB::Black);
      FastLED.show();
      delay(velocity);
    }
    if (sequence[i] == 4) {
      fill_solid( FWD, NUM_LEDS_PER_STRIP, CRGB::Blue);
      FastLED.show();
      delay(velocity);
      fill_solid( FWD, NUM_LEDS_PER_STRIP, CRGB::Black);
      FastLED.show();
      delay(velocity);
    }
    if (sequence[i] == 5) {
      fill_solid( BACK, NUM_LEDS_PER_STRIP, CRGB::Blue);
      FastLED.show();
      delay(velocity);
      fill_solid( BACK, NUM_LEDS_PER_STRIP, CRGB::Black);
      FastLED.show();
      delay(velocity);
    }
    if (sequence[i] == 6) {
      fill_solid( UP, NUM_LEDS_PER_STRIP, CRGB::Blue);
      FastLED.show();
      delay(velocity);
      fill_solid( UP, NUM_LEDS_PER_STRIP, CRGB::Black);
      FastLED.show();
      delay(velocity);
    }
    if (sequence[i] == 7) {
      fill_solid( DOWN, NUM_LEDS_PER_STRIP, CRGB::Blue);
      FastLED.show();
      delay(velocity);
      fill_solid( DOWN, NUM_LEDS_PER_STRIP, CRGB::Black);
      FastLED.show();
      delay(velocity);
    }

  }
  fill_solid( RIGHT, NUM_LEDS_PER_STRIP, CRGB::White);
  fill_solid( LEFT, NUM_LEDS_PER_STRIP, CRGB::White);
  fill_solid( FWD, NUM_LEDS_PER_STRIP, CRGB::White);
  fill_solid( BACK, NUM_LEDS_PER_STRIP, CRGB::White);
  fill_solid( UP, NUM_LEDS_PER_STRIP, CRGB::White);
  fill_solid( DOWN, NUM_LEDS_PER_STRIP, CRGB::White);
  FastLED.delay(250);
  delay(800);
  fill_solid( RIGHT, NUM_LEDS_PER_STRIP, CRGB::Black);
  fill_solid( LEFT, NUM_LEDS_PER_STRIP, CRGB::Black);
  fill_solid( FWD, NUM_LEDS_PER_STRIP, CRGB::Black);
  fill_solid( BACK, NUM_LEDS_PER_STRIP, CRGB::Black);
  fill_solid( UP, NUM_LEDS_PER_STRIP, CRGB::Black);
  fill_solid( DOWN, NUM_LEDS_PER_STRIP, CRGB::Black);
  FastLED.delay(500);

}
void get_sequence()                                                                               //GET SEQUENCE
{
  int flag = 0;

  for (int i = 0; i < level; i++)
  {
    flag = 0;
    while (flag == 0)
    {
      IMU.readSensor();
      if (IMU.getAccelY_mss() < -9) {
        countRIGHT++;
      }
      if (IMU.getAccelY_mss() > 9) {
        countLEFT++;
      }
      if (IMU.getAccelX_mss() > 9) {
        countFWD++;
      }
      if (IMU.getAccelX_mss() < -9) {
        countBACK++;
      }
      if (IMU.getAccelZ_mss() > 9) {
        countUP++;
      }
      if (IMU.getAccelZ_mss() < -9) {
        countDOWN++;

      }
      
//      Serial.print("right");
//Serial.print(countRIGHT);
//      Serial.print("left");
//Serial.print(countLEFT);
//      Serial.print("countBACK");
//Serial.print(countBACK);
//      Serial.print("countFWD");
//Serial.print(countFWD);
//      Serial.print("countUP");
//Serial.print(countUP);
//      Serial.print("countDOWN");
//Serial.println(countDOWN);
//delay(2000);
//        countRIGHT = 0;
//        countLEFT = 0;
//        countFWD = 0;
//        countBACK = 0;
//        countUP = 0;
//        countDOWN = 0;
        
      if (countRIGHT > maxnum)
      {
        fill_solid( RIGHT, NUM_LEDS_PER_STRIP, CRGB::Green);
        FastLED.delay(500);
        delay(500);
        fill_solid( RIGHT, NUM_LEDS_PER_STRIP, CRGB::Black);
        FastLED.delay(500);

        your_sequence[i] = 2;
        flag = 1;
        delay(500);
        if (your_sequence[i] != sequence[i])
        {
          wrong_sequence();
          return;
        }
        fill_solid( RIGHT, NUM_LEDS_PER_STRIP, CRGB::Green);
        FastLED.delay(500);
        delay(500);
        countRIGHT = 0;
        countLEFT = 0;
        countFWD = 0;
        countBACK = 0;
        countUP = 0;
        countDOWN = 0;
      }

      if (countLEFT > maxnum)
      {
        fill_solid( LEFT, NUM_LEDS_PER_STRIP, CRGB::Green);
        FastLED.delay(500);
        delay(500);
        fill_solid( LEFT, NUM_LEDS_PER_STRIP, CRGB::Black);
        FastLED.delay(500);

        your_sequence[i] = 3;
        flag = 1;
        delay(500);
        if (your_sequence[i] != sequence[i])
        {
          wrong_sequence();
          return;
        }
        fill_solid( LEFT, NUM_LEDS_PER_STRIP, CRGB::Green);
        FastLED.delay(500);
        delay(500);
        countRIGHT = 0;
        countLEFT = 0;
        countFWD = 0;
        countBACK = 0;
        countUP = 0;
        countDOWN = 0;
      }

      if (countFWD > maxnum)
      {
        fill_solid( FWD, NUM_LEDS_PER_STRIP, CRGB::Green);
        FastLED.delay(500);
        delay(500);
        fill_solid( FWD, NUM_LEDS_PER_STRIP, CRGB::Black);
        FastLED.delay(500);

        your_sequence[i] = 4;
        flag = 1;
        delay(500);
        if (your_sequence[i] != sequence[i])
        {
          wrong_sequence();
          return;
        }
        fill_solid( FWD, NUM_LEDS_PER_STRIP, CRGB::Green);
        FastLED.delay(500);
        delay(500);
        countRIGHT = 0;
        countLEFT = 0;
        countFWD = 0;
        countBACK = 0;
        countUP = 0;
        countDOWN = 0;
      }

      if (countBACK > maxnum)
      {
        fill_solid( BACK, NUM_LEDS_PER_STRIP, CRGB::Green);
        FastLED.delay(500);
        delay(500);
        fill_solid( BACK, NUM_LEDS_PER_STRIP, CRGB::Black);
        FastLED.delay(500);

        your_sequence[i] = 5;
        flag = 1;
        delay(500);
        if (your_sequence[i] != sequence[i])
        {
          wrong_sequence();
          return;
        }
        fill_solid( BACK, NUM_LEDS_PER_STRIP, CRGB::Green);
        FastLED.delay(500);
        delay(500);
        countRIGHT = 0;
        countLEFT = 0;
        countFWD = 0;
        countBACK = 0;
        countUP = 0;
        countDOWN = 0;
      }
      if (countUP > maxnum)
      {
        fill_solid( UP, NUM_LEDS_PER_STRIP, CRGB::Green);
        FastLED.delay(500);
        delay(500);
        fill_solid( UP, NUM_LEDS_PER_STRIP, CRGB::Black);
        FastLED.delay(500);

        your_sequence[i] = 6;
        flag = 1;
        delay(500);
        if (your_sequence[i] != sequence[i])
        {
          wrong_sequence();
          return;
        }
        fill_solid( UP, NUM_LEDS_PER_STRIP, CRGB::Green);
        FastLED.delay(500);
        delay(500);
        countRIGHT = 0;
        countLEFT = 0;
        countFWD = 0;
        countBACK = 0;
        countUP = 0;
        countDOWN = 0;
      }
      if (countDOWN > maxnum)
      {
        fill_solid( DOWN, NUM_LEDS_PER_STRIP, CRGB::Green);
        FastLED.delay(500);
        delay(500);
        fill_solid( DOWN, NUM_LEDS_PER_STRIP, CRGB::Black);
        FastLED.delay(500);

        your_sequence[i] = 7;
        flag = 1;
        delay(500);
        if (your_sequence[i] != sequence[i])
        {
          wrong_sequence();
          return;
        }
        fill_solid( DOWN, NUM_LEDS_PER_STRIP, CRGB::Green);
        FastLED.delay(500);
        delay(500);
        countRIGHT = 0;
        countLEFT = 0;
        countFWD = 0;
        countBACK = 0;
        countUP = 0;
        countDOWN = 0;
      }
    }
  }
  right_sequence();
}

void wrong_sequence()                                            // wrong
{
  for (int i = 0; i < 3; i++)
  {
    fill_solid( RIGHT, NUM_LEDS_PER_STRIP, CRGB::Red);
    fill_solid( LEFT, NUM_LEDS_PER_STRIP, CRGB::Red);
    fill_solid( FWD, NUM_LEDS_PER_STRIP, CRGB::Red);
    fill_solid( BACK, NUM_LEDS_PER_STRIP, CRGB::Red);
    fill_solid( UP, NUM_LEDS_PER_STRIP, CRGB::Red);
    fill_solid( DOWN, NUM_LEDS_PER_STRIP, CRGB::Red);
    FastLED.delay(250);
    delay(250);
    fill_solid( RIGHT, NUM_LEDS_PER_STRIP, CRGB::Black);
    fill_solid( LEFT, NUM_LEDS_PER_STRIP, CRGB::Black);
    fill_solid( FWD, NUM_LEDS_PER_STRIP, CRGB::Black);
    fill_solid( BACK, NUM_LEDS_PER_STRIP, CRGB::Black);
    fill_solid( UP, NUM_LEDS_PER_STRIP, CRGB::Black);
    fill_solid( DOWN, NUM_LEDS_PER_STRIP, CRGB::Black);
    FastLED.delay(250);

  }
  level = 6; 
  velocity = 1000;
  Serial.println("WRONG SEQUENCE");
  return;
}

void right_sequence()                                                  // RIGHT
{
  Serial.println("RIGHT SEQUENCE");
    for (int i = 0; i < 3; i++)
  {
  fill_solid( RIGHT, NUM_LEDS_PER_STRIP, CRGB::Gold);
  fill_solid( LEFT, NUM_LEDS_PER_STRIP, CRGB::Gold);
  fill_solid( FWD, NUM_LEDS_PER_STRIP, CRGB::Gold);
  fill_solid( BACK, NUM_LEDS_PER_STRIP, CRGB::Gold);
  fill_solid( UP, NUM_LEDS_PER_STRIP, CRGB::Gold);
  fill_solid( DOWN, NUM_LEDS_PER_STRIP, CRGB::Gold);
  FastLED.delay(250);
  delay(250);
  fill_solid( RIGHT, NUM_LEDS_PER_STRIP, CRGB::Black);
  fill_solid( LEFT, NUM_LEDS_PER_STRIP, CRGB::Black);
  fill_solid( FWD, NUM_LEDS_PER_STRIP, CRGB::Black);
  fill_solid( BACK, NUM_LEDS_PER_STRIP, CRGB::Black);
  fill_solid( UP, NUM_LEDS_PER_STRIP, CRGB::Black);
  fill_solid( DOWN, NUM_LEDS_PER_STRIP, CRGB::Black);
  FastLED.delay(250);
  }
  delay(1000);
  velocity -= 100;
}
